/*============================================================================
  File:     Locking-HotSpotSetup.sql

  Summary:  Create some nasty lock waits

  Date:     March 2011

  SQL Server Versions:
		10.0.2531.00 (SS2008 SP1)
		9.00.4035.00 (SS2005 SP3)
------------------------------------------------------------------------------
  Written by Paul S. Randal, SQLskills.com

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  You may alter this code for your own *non-commercial* purposes. You may
  republish altered code as long as you give due credit.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- Let's create a hotspot to watch

/*
USE master;
GO
DROP DATABASE HotSpot;
GO
*/

CREATE DATABASE HotSpot ON PRIMARY (
    NAME = 'HotSpot_data',
    FILENAME = N'D:\SQLskills\HotSpot_data.mdf')
LOG ON (
    NAME = 'HotSpot_log',
    FILENAME = N'C:\SQLskills\HotSpot_log.ldf',
    SIZE = 5MB,
    FILEGROWTH = 1MB);
GO

ALTER DATABASE HotSpot SET RECOVERY SIMPLE;
GO

USE HotSpot;
GO

CREATE TABLE HotSpotTable (
	c1 INT IDENTITY);
CREATE CLUSTERED INDEX HotSpotTable_CL ON
	HotSpotTable (c1);
GO

-- Now start 10 threads....

-- And look at the stats, waiting tasks, latches

-- Now add 50, 50, 50, 50 and watch changes


-- Now do this...
ALTER INDEX HotSpotTable_CL ON HotSpotTable SET (ALLOW_ROW_LOCKS=OFF);
GO

-- And reset wait stats in a new window and look again
